Subject: Re: bug#15138: revno: 114089 change causes cjk characters not shown correctly

From: Jan Djärv <[email-masked]>
Date: Thu, 5 Sep 2013 18:34:19 +0200

Hello.

5 sep 2013 kl. 15:49 skrev Kenichi Handa <[email-masked]>:

> In article <[email-masked]>, Jan Djärv <[email-masked]> writes:
> 
>> Good, closing.
> 
> I have another question about this change.
> 
>      /* Fonts often have characters in other scripts, like symbol, even if they
>         don't match script: symbol.  So check if the character is present
>         in the current face first.  Only enable for NS for now, but should
>         perhaps be general?  */
>      Lisp_Object font_object;
>      XSETFONT (font_object, face->font);
>      if (font_has_char (f, font_object, c)) return face->id;
> 
> With it, face->font may vary depending on the preceding
> character.  So if you have these lines:
>  abc•
>  あいう•
> the two "•"s will be displayed by different fonts.  Isn't it
> better to try the font selected for ASCII as this:
> 
>      XSETFONT (font_object, face->ascii_face->font);

I don't know, I never had that situation.  I guess if the goal is to show same glyphs, ascii_face->font is a better choice.  But if it is to have a consistent look with the surrounding text, it it not.

Consider a buffer where only  あいう• is entered.  I would assume the current font would be a better choice in this case.

	Jan D.